/******/ (function() { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "webos-service":
/*!********************************!*\
  !*** external "webos-service" ***!
  \********************************/
/***/ (function(module) {

"use strict";
module.exports = require("webos-service");

/***/ }),

/***/ "child_process":
/*!********************************!*\
  !*** external "child_process" ***!
  \********************************/
/***/ (function(module) {

"use strict";
module.exports = require("child_process");

/***/ }),

/***/ "fs":
/*!*********************!*\
  !*** external "fs" ***!
  \*********************/
/***/ (function(module) {

"use strict";
module.exports = require("fs");

/***/ }),

/***/ "http":
/*!***********************!*\
  !*** external "http" ***!
  \***********************/
/***/ (function(module) {

"use strict";
module.exports = require("http");

/***/ }),

/***/ "os":
/*!*********************!*\
  !*** external "os" ***!
  \*********************/
/***/ (function(module) {

"use strict";
module.exports = require("os");

/***/ }),

/***/ "path":
/*!***********************!*\
  !*** external "path" ***!
  \***********************/
/***/ (function(module) {

"use strict";
module.exports = require("path");

/***/ }),

/***/ "./service/package.json":
/*!******************************!*\
  !*** ./service/package.json ***!
  \******************************/
/***/ (function(module) {

"use strict";
module.exports = JSON.parse('{"name":"org.webosbrew.inputhook.service","version":"1.4.0","description":"LG Input Hook Service","main":"service.js","scripts":{"test":"echo \\"Error: no test specified\\" && exit 1"},"author":"simon.#1842","license":"BSD"}');

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
!function() {
/*!****************************!*\
  !*** ./service/service.js ***!
  \****************************/
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var pkgInfo = __webpack_require__(/*! ./package.json */ "./service/package.json");

var Service = __webpack_require__(/*! webos-service */ "webos-service");

var child_process = __webpack_require__(/*! child_process */ "child_process");

var http = __webpack_require__(/*! http */ "http");

var path = __webpack_require__(/*! path */ "path");

var fs = __webpack_require__(/*! fs */ "fs");

var os = __webpack_require__(/*! os */ "os");

function ensureDirectoryExistence(filePath) {
  var dirname = path.dirname(filePath);

  if (fs.existsSync(dirname)) {
    return true;
  }

  ensureDirectoryExistence(dirname);
  fs.mkdirSync(dirname);
  return false;
}

var service = new Service(pkgInfo.name);
service.activityManager.create("keepAlive", function (activity) {});
service.register('start', function (message) {
  message.respond({
    "returnValue": true,
    "response": "Started."
  });
});
var autostartScript = "#!/bin/sh\nsleep 60\noutput=$(luna-send -n 1 \"luna://org.webosbrew.inputhook.service/start\" '{}')\n\nif echo \"$output\" | grep -q 'status unknown'; then\n\t/var/lib/webosbrew/init.d/inputhook &\n\texit\nfi\n\nif echo \"$output\" | grep -q 'errorText'; then\n\trm -f /var/lib/webosbrew/init.d/inputhook\nfi";
service.register('autostart', function (message) {
  try {
    ensureDirectoryExistence('/var/lib/webosbrew/init.d/inputhook');
    fs.writeFileSync('/var/lib/webosbrew/init.d/inputhook', autostartScript);
    fs.chmodSync('/var/lib/webosbrew/init.d/inputhook', '755');
    message.respond({
      "returnValue": true,
      "response": "Created autostart script."
    });
  } catch (error) {
    message.respond({
      "returnValue": false,
      "errorText": error.stack
    });
  }
});
var targetNames = ['lginput2'];
var targets = fs.readdirSync("/proc").map(function (x) {
  try {
    return [x, fs.readFileSync('/proc/' + x + '/comm', {
      encoding: 'utf8'
    }).trimRight()];
  } catch (error) {
    return null;
  }
}).filter(function (x) {
  return x != null && targetNames.indexOf(x[1]) > -1;
});
var dir = process.cwd() + '/inputhook';
fs.chmodSync(dir + '/ezinject', '777');

if (!fs.existsSync('/tmp/inputhook')) {
  fs.writeFileSync('/tmp/lginput-hook-lginput2.log', '');

  var _iterator = _createForOfIteratorHelper(targets),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var target = _step.value;
      child_process.exec(dir + '/ezinject -l /tmp/lginput-hook-lginput2.log ' + target[0] + ' ' + dir + '/libinputhookpp.so > /tmp/ezinject-' + target[1] + '.log 2>&1');
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  fs.writeFileSync('/tmp/inputhook', '');
}

var types = {
  'html': 'text/html',
  'js': 'text/javascript',
  'css': 'text/css'
}; // https://github.com/dankogai/js-base64/blob/main/base64.js

var b64ch = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
var b64chs = Array.prototype.slice.call(b64ch);

var b64tab = function (a) {
  var tab = {};
  a.forEach(function (c, i) {
    return tab[c] = i;
  });
  return tab;
}(b64chs);

var b64re = /^(?:[A-Za-z\d+\/]{4})*?(?:[A-Za-z\d+\/]{2}(?:==)?|[A-Za-z\d+\/]{3}=?)?$/;

var _fromCC = String.fromCharCode.bind(String);

function atob(asc) {
  asc = asc.replace(/\s+/g, '');
  if (!b64re.test(asc)) throw new TypeError('malformed base64.');
  asc += '=='.slice(2 - (asc.length & 3));
  var u24,
      bin = '',
      r1,
      r2;

  for (var i = 0; i < asc.length;) {
    u24 = b64tab[asc.charAt(i++)] << 18 | b64tab[asc.charAt(i++)] << 12 | (r1 = b64tab[asc.charAt(i++)]) << 6 | (r2 = b64tab[asc.charAt(i++)]);
    bin += r1 === 64 ? _fromCC(u24 >> 16 & 255) : r2 === 64 ? _fromCC(u24 >> 16 & 255, u24 >> 8 & 255) : _fromCC(u24 >> 16 & 255, u24 >> 8 & 255, u24 & 255);
  }

  return bin;
}

;

function generatePassword(len) {
  var out = '';

  for (var i = 0; i < len; i++) {
    out += Math.floor(Math.random() * 0x10).toString(16);
  }

  return out.toUpperCase();
}

function getLocalIP() {
  var interfaces = os.networkInterfaces();

  for (var devName in interfaces) {
    var iface = interfaces[devName];

    for (var i = 0; i < iface.length; i++) {
      var alias = iface[i];

      if (alias.family === 'IPv4' && alias.address !== '127.0.0.1' && !alias.internal) {
        return alias.address;
      }
    }
  }

  return '0.0.0.0';
}

if (!ensureDirectoryExistence('/home/root/.config/lginputhook/keybinds.json')) {
  fs.writeFileSync('/home/root/.config/lginputhook/keybinds.json', '{}');
}

function isLocalhost(ip) {
  return ip == '::1' || ip.indexOf('127.0.0.1') != -1;
}

var password = generatePassword(8);
var passwordShown = false;

function respond(res, code, headers, data) {
  if (headers) {
    res.writeHead(code, headers);
  } else {
    res.writeHead(code);
  }

  if (data) {
    res.write(data);
  }

  res.end();
}

var server = http.createServer(function (req, res) {
  var path = req.url;
  var header = req.headers.authorization || '';
  var token = header.split(/\s+/).pop() || '';
  var auth = atob(token);
  var parts = auth.split(/:/);
  var authUsername = parts.shift();
  var authPassword = parts.join(':');

  if (!isLocalhost(req.socket.remoteAddress)) {
    if (authPassword != password) {
      respond(res, 401, {
        'WWW-Authenticate': 'Basic'
      });
      return;
    }
  }

  if (req.method == 'GET') {
    if (path.substring(0, 6) == '/logs/') {
      fs.readFile(path.replace('logs', 'tmp'), function (error, data) {
        if (error) {
          data = error.code + ' ' + error.path;
        }

        respond(res, 200, {
          'Content-Type': 'text/plain',
          'Content-Length': data.length
        }, data);
      });
    } else if (path.substring(0, 4) == '/ip/') {
      var data = getLocalIP();
      respond(res, 200, {
        'Content-Type': 'text/plain',
        'Content-Length': data.length
      }, data);
      return;
    } else if (path.substring(0, 10) == '/password/') {
      var data = isLocalhost(req.socket.remoteAddress) ? password : '';
      respond(res, 200, {
        'Content-Type': 'text/plain',
        'Content-Length': data.length
      }, data);
      return;
    } else if (path.substring(0, 10) == '/apps.json') {
      service.call("luna://com.webos.applicationManager/listApps", {}, function (response) {
        if (!response.payload.returnValue) response.payload.apps = [{
          "title": "Could not get apps: " + response.payload.errorCode + " " + response.payload.errorText,
          "id": "org.webosbrew.inputhook"
        }];
        var data = Buffer(JSON.stringify(response.payload));
        respond(res, 200, {
          'Content-Type': 'application/json',
          'Content-Length': data.length
        }, data);
      });
      return;
    } else if (path.substring(0, 8) == '/config/') {
      fs.readFile('/home/root/.config/lginputhook/' + path.substring(8), function (error, data) {
        if (error) {
          data = "{}";
        }

        respond(res, 200, {
          'Content-Type': 'application/json',
          'Content-Length': data.length
        }, data);
      });
    } else {
      if (path[path.length - 1] == '/') {
        path += 'index.html';
      }

      fs.readFile('./interface' + path, function (error, data) {
        if (error) {
          respond(res, error.code == 'ENOENT' ? 404 : 500);
          return;
        }

        respond(res, 200, {
          'Content-Type': types[path.split('.')[path.split('.').length - 1]] || 'text/plain',
          'Content-Length': data.length
        }, data);
      });
    }
  } else if (req.method == 'POST') {
    if (path.substring(0, 8) == '/config/') {
      var body = [];
      req.on('data', function (chunk) {
        body.push(chunk);
      });
      req.on('end', function () {
        var data = Buffer.concat(body).toString();

        try {
          JSON.parse(data);
        } catch (error) {
          respond(res, 400, false, error.toString());
          return;
        }

        fs.writeFile('/home/root/.config/lginputhook/' + path.substring(8), data, function (error) {
          if (error) {
            respond(res, 500, false, error.code + ' ' + error.path);
          } else {
            var response = 'Successfully saved to ' + path;
            respond(res, 200, {
              'Content-Type': 'text/plain',
              'Content-Length': response.length
            }, response);
          }
        });
      });
    } else if (path == '/reboot') {
      child_process.exec('reboot');
      respond(res, 200);
      process.exit();
    } else {
      respond(res, 404);
    }
  } else {
    respond(res, 405);
  }
});
server.listen(1842);
}();
/******/ })()
;